#pragma once

#include "GeneratorRule.h"

class BlockTypeGeneratorRule : public GeneratorRule
{
private:
    int blockType;

public:
    BlockTypeGeneratorRule();
    Framework::Either<Block*, int> createBlock(
        int x, int y, int z, int dimensionId) override;
    void setBlockTypeId(int blockType);
    int getBlockTypeId() const;
};

class BlockTypeGeneratorRuleFactory
    : public GeneratorRuleFactory<BlockTypeGeneratorRule>
{
public:
    BlockTypeGeneratorRuleFactory();
    BlockTypeGeneratorRule* createValue(
        Framework::JSON::JSONObject* zJson) const override;
    BlockTypeGeneratorRule* fromJson(
        Framework::JSON::JSONObject* zJson) const override;
    Framework::JSON::JSONObject* toJsonObject(
        BlockTypeGeneratorRule* zObject) const override;
    JSONObjectValidationBuilder* addToValidator(
        JSONObjectValidationBuilder* builder) const override;
    const char* getTypeToken() const override;
};