#include "BlockTypeNameFactory.h"

const Framework::Text BlockTypeNameFactory::TYPE_ID = "BlockTypeName";

BlockTypeNameFactory::BlockTypeNameFactory()
    : SimpleTypeFactory<Framework::Text*>(),
      blockTypeNames(0)
{}

BlockTypeNameFactory::~BlockTypeNameFactory()
{
    if (blockTypeNames)
    {
        blockTypeNames->release();
    }
}

void BlockTypeNameFactory::setBlockTypeNames(
    Framework::RCArray<Framework::Text>* blockTypeNames)
{
    this->blockTypeNames = blockTypeNames;
}

Framework::Text* BlockTypeNameFactory::fromJson(
    Framework::JSON::JSONValue* zJson) const
{
    return new Framework::Text(zJson->asString()->getString());
}

Framework::JSON::JSONValue* BlockTypeNameFactory::toJson(
    Framework::Text* value) const
{
    return new Framework::JSON::JSONString(value->getText());
}

Framework::Validator::DataValidator* BlockTypeNameFactory::getValidator() const
{
    if (!blockTypeNames)
    {
        return Framework::Validator::DataValidator::buildForString()
            ->finishString();
    }
    else
    {
        return Framework::Validator::DataValidator::buildForString()
            ->whichIsOneOf(*blockTypeNames)
            ->finishString();
    }
}